library ieee;
use ieee.std_logic_1164.all;
use ieee.numeric_std.all;
--use ieee.std_logic_unsigned.all;
use ieee.std_logic_signed.all;

entity testbench is
end entity testbench;

architecture tb_arch of testbench is
  -- perioda hodin 
  constant clk_period   : time := 20 ns;
  constant reset_time   : time := 100 ns;
  constant data_width   : integer := 4;
  
  -- prepajacie signaly
  signal clk            : std_logic;
  signal rst            : std_logic;
  signal data_in        : std_logic_vector(data_width-1 downto 0);           
  signal output         : std_logic;
      

begin
  -- instancia testovanej komponenty
  UUT : entity work.CHANGE_ENT
  port map( CLK            => clk,
            RST            => rst,     
            -- ----------------- INPUT INTERFACE ----------------------- 
            DATA_IN        => data_in,
              
            -- ----------------- OUTPUT INTERFACE ----------------------
            OUTPUT         => output
   );   

  -- generovanie hodinoveho signalu 
  clk_gen :  process 
  begin  
    clk     <='1';
    wait for clk_period/2;
    clk     <='0';
    wait for clk_period/2;
  end process clk_gen;
  
  resetgen: process
   begin
      rst   <= '1';
      wait for 2*reset_time;
      rst   <= '0';
      wait for 20*clk_period;
      rst   <= '0';
      wait;
   end process;

  -- generovanie vstupov
  behaviour : process
  begin
    data_in <= std_logic_vector(to_unsigned(6, DATA_WIDTH));
    wait for 2*reset_time+ clk_period;
    wait for 5*clk_period;
    data_in <= std_logic_vector(to_unsigned(2, DATA_WIDTH)); 
    wait;
  end process behaviour;  
  
end architecture tb_arch;
