library ieee;
use ieee.std_logic_1164.all;
use ieee.numeric_std.all;

entity testbench is
end entity testbench;

architecture tb_arch of testbench is
  -- perioda hodin 
  constant clk_period   : time := 20 ns;
  constant reset_time   : time := 100 ns;
  constant data_width   : integer := 16;
  
  -- prepajacie signaly
  signal clk            : std_logic;
  signal rst            : std_logic;
      
      -- ----------------- INPUT DATA --------------------------------- 
  signal s_0            : std_logic_vector(data_width-1 downto 0);
  signal s_1            : std_logic_vector(data_width-1 downto 0);
  signal s_2            : std_logic_vector(data_width-1 downto 0);
  signal s_3            : std_logic_vector(data_width-1 downto 0);

  signal not_cyc_write  : std_logic;
              
      -- ----------------- output data ---------------------------
  signal bar            : std_logic_vector(data_width-1 downto 0);
      

begin
  -- instancia testovanej komponenty
  UUT : entity work.BDU_FSM_TL_ENT
  port map( CLK            => clk,
            RST            => rst,
            -- ----------------- INPUT DATA --------------------------------- 
            S_0            => s_0,
            S_1            => s_1,
            S_2            => s_2,
            S_3            => s_3,

            NOT_CYC_WRITE  => not_cyc_write,
            -- ----------------- OUTPUT DATA ---------------------------
            BAR            => bar       
  );

  -- generovanie hodinoveho signalu 
  clk_gen :  process 
  begin  
    clk     <='1';
    wait for clk_period/2;
    clk     <='0';
    wait for clk_period/2;
  end process clk_gen;
  
  resetgen: process
   begin
      rst   <= '1';
      wait for reset_time;
      rst   <= '0';
      wait for 20*clk_period;
      rst   <= '0';
      wait;
   end process;

  -- generovanie vstupov
  behaviour : process
  begin
    s_0        <= "0000000000000001";
    s_1        <= "0000000000000010";
    s_2        <= "0000000000001000";
    s_3        <= "0000000000000100";
  
    not_cyc_write    <= '0';
    wait for reset_time;
    wait for 2*clk_period;
    not_cyc_write    <= '1';
    wait for reset_time;
    wait for 2*clk_period;
    not_cyc_write    <= '0';
    wait for clk_period;
    s_0        <= "0000000000000010";
    wait for clk_period;
    s_1        <= "0000000000000100";
    wait for clk_period;
    s_2        <= "0000000000001000";
    wait for clk_period;
    wait for clk_period;
    s_3        <= "0000000000010000";
    not_cyc_write    <= '1';
    
    wait;
  end process behaviour; 
   
end architecture tb_arch;
