library ieee;
use ieee.std_logic_1164.all;
use ieee.numeric_std.all;

entity testbench is
end entity testbench;

architecture tb_arch of testbench is
  -- perioda hodin 
  constant clk_period   : time := 20 ns;
  constant reset_time   : time := 100 ns;
  constant data_width   : integer := 16;
  
  -- prepajacie signaly
  signal clk         : std_logic;
  signal rst         : std_logic;  
  signal L           : std_logic;
  signal R           : std_logic;
  signal T           : std_logic;
  signal B           : std_logic;
  signal X           : std_logic_vector(DATA_WIDTH - 1 downto 0);
  signal Y           : std_logic_vector(DATA_WIDTH - 1 downto 0);
  
      

begin
  -- instancia testovanej komponenty
  UUT : entity work.DIR_ENT
  port map( CLK         => clk,
            RST         => rst,
            L           => l,
            R           => r,
            T           => t,
            B           => b,
            X           => x,
            Y           => y
  );

  -- generovanie hodinoveho signalu 
  clk_gen :  process 
  begin  
    clk     <='1';
    wait for clk_period/2;
    clk     <='0';
    wait for clk_period/2;
  end process clk_gen;
  
  resetgen: process
   begin
      rst   <= '1';
      wait for reset_time;
      rst   <= '0';
      --wait for 10*reset_time;
      --rst   <= '1';
      wait;
   end process;

  -- generovanie vstupov
  behaviour : process
  begin
    x        <= std_logic_vector(to_unsigned(1, DATA_WIDTH));
    y        <= std_logic_vector(to_unsigned(2, DATA_WIDTH));
    wait for reset_time;
    wait for reset_time;
    wait for clk_period;
    x        <= std_logic_vector(to_unsigned(1, DATA_WIDTH));
    y        <= std_logic_vector(to_unsigned(3, DATA_WIDTH));
    wait for reset_time;
    wait for clk_period;
    x        <= std_logic_vector(to_unsigned(2, DATA_WIDTH));
    y        <= std_logic_vector(to_unsigned(3, DATA_WIDTH));
    wait;
  end process behaviour; 
   
end architecture tb_arch;
