library ieee;
use ieee.std_logic_1164.all;

entity testbench is
end entity testbench;

architecture tb_arch of testbench is
  -- perioda hodin 
  constant clk_period   : time := 20 ns;
  constant reset_time   : time := 100 ns;
  constant data_width   : integer := 16;
  
  -- prepajacie signaly
  signal clk         : std_logic;
  signal rst         : std_logic;  
  signal act         : std_logic;
  signal vld         : std_logic;
  signal l           : std_logic;
  signal r           : std_logic;
  signal t           : std_logic;
  signal b           : std_logic;
  signal x_speed     : std_logic_vector(data_width - 1 downto 0);
  signal y_speed     : std_logic_vector(data_width - 1 downto 0);
  
      

begin
  -- instancia testovanej komponenty
  UUT : entity work.MOVE_ENT
  port map( CLK         => clk,
            RST         => rst,
            ACT         => act,
            VLD         => vld,
            L           => l,
            R           => r,
            T           => t,
            B           => b,
            X_SPEED     => x_speed,
            Y_SPEED     => y_speed
  );

  -- generovanie hodinoveho signalu 
  clk_gen :  process 
  begin  
    clk     <='1';
    wait for clk_period/2;
    clk     <='0';
    wait for clk_period/2;
  end process clk_gen;
  
  resetgen: process
   begin
      rst   <= '1';
      wait for reset_time;
      rst   <= '0';
      --wait for 10*reset_time;
      --rst   <= '1';
      wait;
   end process;

  -- generovanie vstupov
  behaviour : process
  begin
    act        <= '0';
    l          <= '0';
    r          <= '1';
    t          <= '0';
    b          <= '0';
    wait for reset_time;
    wait for clk_period;
    act        <= '1';
    wait for 5*clk_period;
    act        <= '0';
    
    l          <= '1';
    r          <= '0';
    t          <= '0';
    b          <= '0';
    --wait for reset_time;
    wait for 2*clk_period;
    act        <= '1';
    wait for 5*clk_period;
    act        <= '0';
    
    l          <= '0';
    r          <= '0';
    t          <= '1';
    b          <= '0';
    --wait for reset_time;
    wait for 2*clk_period;
    act        <= '1';
    wait for 6*clk_period;
    act        <= '0';
    
    l          <= '0';
    r          <= '0';
    t          <= '0';
    b          <= '1';
    --wait for reset_time;
    wait for 2*clk_period;
    act        <= '1';
    wait for 5*clk_period;
    act        <= '0';
    
    l          <= '0';
    r          <= '0';
    t          <= '0';
    b          <= '0';
    --wait for reset_time;
    wait for 2*clk_period;
    act        <= '1';
    wait for 3*clk_period;
    act        <= '0';

    l          <= '0';
    r          <= '0';
    t          <= '0';
    b          <= '1';
    --wait for reset_time;
    wait for 2*clk_period;
    act        <= '1';
    wait for 5*clk_period;
    act        <= '0';
    wait;
  end process behaviour; 
   
end architecture tb_arch;
