library ieee;
use ieee.std_logic_1164.all;

entity testbench is
end entity testbench;

architecture tb_arch of testbench is
  -- perioda hodin 
  constant clk_period   : time := 20 ns;
  constant reset_time   : time := 100 ns;
  constant data_width   : integer := 16;
  
  -- prepajacie signaly
  signal clk         : std_logic;
  signal rst         : std_logic;
  signal act         : std_logic;
  signal x           : std_logic_vector(data_width-1 downto 0);
  signal y           : std_logic_vector(data_width-1 downto 0);
  signal barrier     : std_logic_vector(3 downto 0);
  
  
  
  
  signal addr_x      : std_logic_vector(DATA_WIDTH-1 downto 0);
  signal addr_y      : std_logic_vector(DATA_WIDTH-1 downto 0);
  signal rd_wr       : std_logic;
  signal data_out    : std_logic_vector(3 downto 0);
  signal data_in     : std_logic_vector(3 downto 0);
  signal mem_act     : std_logic;
  signal mem_vld     : std_logic;

  signal vld         : std_logic;
  
      

begin
  -- instancia testovanej komponenty
  UUT : entity work.MU_ENT
  port map( CLK         => clk,
            RST         => rst,
            ACT         => act,
            X           => x,
            Y           => y,
            BARRIER     => barrier,

            ADDR_X      => addr_x,
            ADDR_Y      => addr_y,
            RD_WR       => rd_wr,
            DATA_OUT    => data_out,
            DATA_IN     => data_in,
            MEM_ACT     => mem_act,
            MEM_VLD     => mem_vld,
            VLD         => vld
  );

  -- generovanie hodinoveho signalu 
  clk_gen :  process 
  begin  
    clk     <='1';
    wait for clk_period/2;
    clk     <='0';
    wait for clk_period/2;
  end process clk_gen;
  
  resetgen: process
   begin
      rst   <= '1';
      wait for reset_time;
      rst   <= '0';
      --wait for 10*reset_time;
      --rst   <= '1';
      wait;
   end process;

  -- generovanie vstupov
  behaviour : process
  begin
    mem_vld    <= '0';
    act        <= '0';
    x          <= "0000000000000110";
    y          <= "0000000000001100";
    barrier    <= "0101";
    wait for reset_time+clk_period;
    act        <= '1';
    
    -- 1
    -- cteni
    wait for 3*clk_period;
    mem_vld    <= '1';
    data_in    <= "1000";
    --zapis
    wait for clk_period;
    mem_vld    <= '0';
    wait for 3*clk_period;
    mem_vld    <= '1';
    wait for clk_period;
    mem_vld    <= '0';
    -- 2
    -- cteni
    wait for 3*clk_period;
    mem_vld    <= '1';
    data_in    <= "0011";
    -- zapis
    wait for clk_period;
    mem_vld    <= '0';
    wait for 3*clk_period;
    --mem_vld    <= '1';
    wait for clk_period;
    mem_vld    <= '0';
    -- 3
    -- cteni
    wait for 3*clk_period;
    mem_vld    <= '1';
    data_in    <= "0001";
    -- zapis
    wait for clk_period;
    mem_vld    <= '0';
    wait for 3*clk_period;
    mem_vld    <= '1';
    wait for clk_period;
    mem_vld    <= '0';
    -- 4
    -- cteni
    wait for 3*clk_period;
    mem_vld    <= '1';
    data_in    <= "0001";
    -- zapis
    wait for clk_period;
    mem_vld    <= '0';
    wait for 3*clk_period;
    mem_vld    <= '1';
    wait for clk_period;
    mem_vld    <= '0';
    --5 
    -- cteni
    wait for 3*clk_period;
    mem_vld    <= '1';
    data_in    <= "0001";
    -- zapis
    wait for clk_period;
    mem_vld    <= '0';
    wait for 3*clk_period;
    mem_vld    <= '1';
    wait for clk_period;
    mem_vld    <= '0';
    -- prisel valid, ukoncim act
    wait for clk_period;
    act        <= '0';
    
    -- dalsi kolo
    ---------------------------------------------------
    mem_vld    <= '0';
    act        <= '0';
    x          <= "0000000000000110";
    y          <= "0000000000001100";
    barrier    <= "0101";
    wait for reset_time+clk_period;
    act        <= '1';
    
    -- 1
    -- cteni
    wait for 3*clk_period;
    mem_vld    <= '1';
    data_in    <= "1000";
    --zapis
    wait for clk_period;
    mem_vld    <= '0';
    wait for 3*clk_period;
    mem_vld    <= '1';
    wait for clk_period;
    mem_vld    <= '0';
    -- 2
    -- cteni
    wait for 3*clk_period;
    mem_vld    <= '1';
    data_in    <= "0001";
    -- zapis
    wait for clk_period;
    mem_vld    <= '0';
    wait for 3*clk_period;
    mem_vld    <= '1';
    wait for clk_period;
    mem_vld    <= '0';
    -- 3
    -- cteni
    wait for 3*clk_period;
    mem_vld    <= '1';
    data_in    <= "0001";
    -- zapis
    wait for clk_period;
    mem_vld    <= '0';
    wait for 3*clk_period;
    mem_vld    <= '1';
    wait for clk_period;
    mem_vld    <= '0';
    -- 4
    -- cteni
    wait for 3*clk_period;
    mem_vld    <= '1';
    data_in    <= "0001";
    -- zapis
    wait for clk_period;
    mem_vld    <= '0';
    wait for 3*clk_period;
    mem_vld    <= '1';
    wait for clk_period;
    mem_vld    <= '0';
    --5 
    -- cteni
    wait for 3*clk_period;
    mem_vld    <= '1';
    data_in    <= "0001";
    -- zapis
    wait for clk_period;
    mem_vld    <= '0';
    wait for 3*clk_period;
    mem_vld    <= '1';
    wait for clk_period;
    mem_vld    <= '0';
    -- prisel valid, ukoncim act
    wait for clk_period;
    act        <= '0';
    wait;
  end process behaviour; 
   
end architecture tb_arch;
