-----------------------------------------------------------------------------
-- Project Name: Robot unit
-- File Name:    shift.vhd
-- Description:  Shift Right Unit
-- Author:       Jakub Podivinsky <xpodiv01@stud.fit.vutbr.cz> 
-- Date:         28.9.2012 
-- --------------------------------------------------------------------------

library ieee;
use ieee.std_logic_1164.all;
use ieee.std_logic_arith.all;
use ieee.std_logic_unsigned.all;
--use ieee.numeric_std.all;

-- ==========================================================================
--                              ENTITY DECLARATION
-- ==========================================================================
entity SHIFTR is
   generic
   (
      DATA_WIDTH  : integer := 16       
   );

   port
   (
      --CLK         : in  std_logic;
      --RST         : in  std_logic;
      START       : in std_logic;
            
      -- ----------------- INPUT INTERFACE ----------------------------------
      INPUT       : in  std_logic_vector(DATA_WIDTH-1 downto 0); -- register A
      N           : in  integer; --std_logic_vector(DATA_WIDTH-1 downto 0); -- register B  
           
      -- ----------------- OUTPUT INTERFACE ---------------------------------      
      SHIFTR_RESULT : out std_logic_vector(DATA_WIDTH-1 downto 0);
      SHIFTR_VLD    : out std_logic
   );
   
end entity;

-- ==========================================================================
--                           ARCHITECTURE DESCRIPTION
-- ==========================================================================
architecture SHIFTR_ARCH of SHIFTR is

-- ==========================================================================
--                                      TYPES
-- ==========================================================================

-- ==========================================================================
--                                    CONSTANTS
-- ==========================================================================

-- ==========================================================================
--                                     SIGNALS
-- ==========================================================================


begin
   process (START, INPUT, N)
   begin
      if (START = '1') then
         SHIFTR_RESULT <= to_stdlogicvector(to_bitvector(INPUT) srl N);--to_integer(unsigned(N)) );
         SHIFTR_VLD <= '1';
      else
         SHIFTR_RESULT <= (others=>'0');
         SHIFTR_VLD <= '0';
      end if;
   end process;
end architecture;
